source simpleFS.tcl
#load ../Obfuscate/obfuscateObs-Lin64.so Obfuscateobs

switch $tcl_platform(os) {
  Linux {
    set ext .so
  }
  Darwin {
    set ext .dylib
  }
  "Windows NT" {
    set ext .dll
  }
}

load ./obfuscateObs$ext Obfuscateobs


if {$argv eq ""} {
  puts "tclsh addToFile.tcl targetFile ??-prefix prefixFolder/" folder/file... 
  exit
}
set target [lindex $argv 0]

# puts "ARGV: $argv0 -- $argv"

if {[lsearch $argv -prefix] >= 0} {
  set prefix [lindex $argv 2]
  set start 3
}  else {
  set prefix ""
  set start 1
}
set fs [simpleFS create newFS]
$fs mount $target

proc addRecursive {name} {
  global fs
  global prefix
  
  if {[file type $name] eq "file"} {
      set if [open $name r]
      fconfigure $if -translation binary -encoding binary
      set d [read $if]
      close $if
#  puts "ADDING : $name"
#      set crypz [obs_shrink $d]
      set crypz $d
      $fs writeFile $prefix$name $crypz
  } else {
    foreach nm [glob nocomplain $name/*] {
      if {[file type $nm] eq "directory"} {
        addRecursive $nm
      } elseif {[file type $nm] eq "file"} {
        set if [open $nm r]
        fconfigure $if -translation binary -encoding binary
        set d [read $if]
        close $if
#  puts "ADDING : $nm -> $prefix$nm"
#        set crypz [obs_shrink $d]
        set crypz $d
        $fs writeFile $prefix$nm $crypz
      }
    }
  }
}

foreach f [lrange $argv $start end] {
  addRecursive $f
}

# $fs pprint

exit
