foreach req {-vfs } {
  if {![dict exists $argv $req]} {
    puts "Missing required arg $req"
    puts "bld -vfs SOURCES_VFS_NAME ?-obf AlternativeObfuskit?"
    exit
  }
}

set id [dict get $argv -vfs]

set base [string map {{.vfs} ""} $id]
set vfs $base.vfs

set prefix ""

if {$tcl_platform(platform) eq "windows"} {
  set output $base.exe
} else {
  set output $base
}

if {$argv0 eq "bld.tcl"} {
  set obf ./obfuskit
} else {
  set obf $argv0
}

if {[dict exists $argv -obf]} {
  set obf [dict get $argv -obf]
}

if {[catch {puts "file copy -force $obf $base"}]} {
  tk_messageBox -type ok -message "file copy -force $obf $base"
}
file copy -force $obf $base

set myFS [vfs::simplefs::Mount $base foo]
# $myFS pprint

if {$argv0 ne "bld.tcl"} {
  if {[catch {file delete foo/simpliskit/main.tcl} yy]} {
    if {[catch { puts "DELETE RTN: $yy"}]} {
      tk_messageBox -type ok -message "DELETE RTN: $yy"
    }
  }
}

proc writeFile {nm d} {
  set of [open foo/$nm w]
  fconfigure $of -translation binary -encoding binary
  puts $of $d
  close $of
}

proc addRecursive {name} {
  global fs
  global vfs
  global prefix

  catch {  puts "addRecursive $name" }

  if {[file type $name] eq "file"} {
      set if [open $name r]
      fconfigure $if -translation binary -encoding binary
      set d [read $if]
      close $if
  	set name2 [string map "$vfs simpleVFS.vfs" $name]
  catch {puts "ADDING1 : $name"}
      writeFile $prefix$name2 $d
  } else {
    foreach nm [glob -nocomplain $name/*] {
      if {[file type $nm] eq "directory"} {
        addRecursive $nm
      } elseif {[file type $nm] eq "file"} {
        set if [open $nm r]
        fconfigure $if -translation binary -encoding binary
        set d [read $if]
        close $if
  	set nm2 [string map "$vfs simpleVFS.vfs" $nm]
  catch {puts "ADDING2 : $nm -> $prefix$nm2"}
        writeFile $prefix$nm2 $d
      }
    }
  }
}

addRecursive $vfs

after idle exit
