# Invoke as ./convertToO file1 file2
# puts "pwd: [pwd]"
# puts "GLOB: [glob [pwd]/*]"
# parray tcl_platform

if {$argv eq ""} {
  puts "convertToO file1 file2"
  puts "convertToO -expand file1 file2"
  exit
}
set me simpleVFS
lappend auto_path $me.vfs/library

if {[info command obs_saveData] eq ""} {
  switch $tcl_platform(os) {
    Linux {
      load ./obfuscateObs.so Obfuscateobs
    }
    "Windows NT" {
      load ./obfuscateObs.dll Obfuscateobs
    }
    Darwin {
      load ./obfuscateObs.dylib Obfuscateobs
    }
  }
}

if {[lsearch $argv -expand] == 0} {
  foreach fl [lrange $argv 1 end] {
    if {![file exists $fl]} {continue}
    set if [open $fl r]
    fconfigure $if -translation binary -encoding binary
    set d [read $if]
    close $if
    set d2 [obs_expand $d]
    set nm [string map {.otxt .txt .o .tcl} $fl]
    set of [open $nm w]
    puts $of $d2
    close $of
  }
} else {
  foreach fl $argv {
    if {![file exists $fl]} {continue}
    set if [open $fl r]
    set d [read $if]
    close $if
    set nm [string map {.txt .otxt .tcl .o} $fl]
    obs_saveData $nm $d
  }
}

exit 0

