#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>


/*------------------------------------------------------------------------
* int main(int argc, char *argv[])--
*    Converts a numeric file into a "C" byte array suitable for
*    merging into other "C" code.
* Arguments:
*   inputFile Name of input file
*   varName   Name of "C" array to create
*   Generates output to stdout.
*     >  outputFile
* 
* Results:
*   
* 
* Side Effects:
*   Also creates varNameLen as int with length of array.
------------------------------------------------------------------------*/
int main(int argc, char *argv[]) {
  FILE *infl;
  char b;
  int i = 0;
  
  if (argc < 2) {
    printf("makeObsIncl inputFile varName > outputFile\n");
    exit(-1);
  }

  printf("static unsigned char %s[] = {\n", argv[2]);
  infl=fopen(argv[1], "rb");
  
  while (fread(&b, 1, 1, infl)) {
    printf("0x%x, ", (b & 0xff) );
    if ( (i++%10) == 9) {
      printf("\n");
    }
  }
  printf("0x00};\n");
  printf("int %sLen = %d;\n", argv[2], i);
  exit(0);
}
