#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <zlib.h>


// Return an expanded, unobscured copy of the input data
// encrypted 	Raw data
// inputLen	Number of bytes
// expLen 	Returned number of bytes

unsigned char *obsExpand (unsigned char *encrypted, int inputLen, int *expLen) {

// printf("START EXP\n"); fflush(stdout);
  z_stream zstr;
  unsigned char* tmp1 = encrypted;
  unsigned char* plain = encrypted;
  int len;
// printf("INPUTLEN: %d\n", inputLen);

  unsigned char* out = (unsigned char*) calloc(inputLen*50+1,1);

  int stat, j, i;
  char s;
  

  zstr.zalloc = Z_NULL;
  zstr.zfree = Z_NULL;
  zstr.data_type = Z_TEXT;
  zstr.opaque = Z_NULL;
  
//   printf("CRYPT LEN: %d\n", inputLen); fflush(stdout);
  if ((stat=inflateInit (&zstr)) != Z_OK) {
    fprintf(stderr, "inflateInit FAIL: %d\n", stat);
  }

  zstr.next_in = (Bytef*)encrypted;
  zstr.avail_in = inputLen;
  zstr.total_in = 0;  
  zstr.next_out = (Bytef*)out;
  zstr.avail_out = inputLen*50;

  stat= inflate(&zstr, Z_FINISH);
  // printf("STAT: %d\n", stat);
  if ((stat != Z_OK) && (stat != Z_STREAM_END)) { 
// Don't print out on Windows - or anyplace else.
//     fprintf(stderr, "FAILED inflate: %d\n", stat);
     *expLen = -1;
     return((unsigned char *) NULL);
  }
     *expLen = (inputLen*50)-zstr.avail_out;
// printf("EXPLEN1: %d\n", (inputLen*50)-zstr.avail_out);
  return(out);
}

// Shrink and obfuscate data
// plain	The plaintext data (may be binary)
// inputLen	Number of bytes
// rtn		Pointer to pointer to receive shrunken data
// Returns number of bytes in rtn

int obsShrink (unsigned char *plain, int inputLen, unsigned char **rtn) {
  int used;
  unsigned char *crypt;
  z_stream zstr;

  int stat, i, j;
  unsigned char s, *text;
  int extr;

  if (inputLen > 5000) {
    extr=inputLen/100;
  } else {
    extr=500;
  }

  crypt = (unsigned char*) calloc(inputLen+extr,1);

// printf("Shrink: crypt: %lxx &%lxx\n", crypt, &crypt);

  zstr.zalloc = Z_NULL;
  zstr.zfree = Z_NULL;
  zstr.data_type = Z_TEXT;
  zstr.opaque = Z_NULL;
  
  if ((stat=deflateInit (&zstr, 6)) != Z_OK) {
    printf("deflateInit FAIL: %d\n", stat);
  }

  // printf("stlen text: %d\n", (int)strlen(text));
  zstr.next_in = (Bytef*) plain;
  zstr.avail_in = inputLen;
  zstr.total_in = 0;  
  zstr.next_out = (Bytef*) crypt;
  zstr.avail_out = inputLen+extr;
     
  stat= deflate(&zstr, Z_FINISH);
  used= (int)((inputLen+extr)-zstr.avail_out);


  *rtn = crypt;
  return(inputLen+extr-zstr.avail_out);
}

