namespace eval parsePE32 {


set DataDirs {
	Export
	Import
	Resource
	Exception 
	Certificate 
	Base 
	Debug
	Architecture 
	Global  
	TLS  
	Load  
	Bound  
	IAT 
	Delay  
	CLR  
	Reserved
}

set DosHdr {typedef struct _IMAGE_DOS_HEADER {  // DOS .EXE header
    USHORT e_magic;         // Magic number
    USHORT e_cblp;          // Bytes on last page of file
    USHORT e_cp;            // Pages in file
    USHORT e_crlc;          // Relocations
    USHORT e_cparhdr;       // Size of header in paragraphs
    USHORT e_minalloc;      // Minimum extra paragraphs needed
    USHORT e_maxalloc;      // Maximum extra paragraphs needed
    USHORT e_ss;            // Initial (relative) SS value
    USHORT e_sp;            // Initial SP value
    USHORT e_csum;          // Checksum
    USHORT e_ip;            // Initial IP value
    USHORT e_cs;            // Initial (relative) CS value
    USHORT e_lfarlc;        // File address of relocation table
    USHORT e_ovno;          // Overlay number
    USHORT e_res[4];        // Reserved words
    USHORT e_oemid;         // OEM identifier (for e_oeminfo)
    USHORT e_oeminfo;       // OEM information; e_oemid specific
    USHORT e_res2[10];      // Reserved words
    LONG   e_lfanew;        // File address of new exe header
  } IMAGE_DOS_HEADER, *PIMAGE_DOS_HEADER;
}

set MagicWord {USHORT sig1;
  USHORT sig2};


set ImgHdr {typedef struct _IMAGE_FILE_HEADER {
    USHORT  Machine;
    USHORT  NumberOfSections;
    ULONG   TimeDateStamp;
    ULONG   PointerToSymbolTable;
    ULONG   NumberOfSymbols;
    USHORT  SizeOfOptionalHeader;
    USHORT  Characteristics;
} IMAGE_FILE_HEADER, *PIMAGE_FILE_HEADER;
}

set OptHdr10b {typedef struct _IMAGE_OPTIONAL_HEADER {
    //
    // Standard fields.
    //
    USHORT  Magic;
    UCHAR   MajorLinkerVersion;
    UCHAR   MinorLinkerVersion;
    ULONG   SizeOfCode;
    ULONG   SizeOfInitializedData;
    ULONG   SizeOfUninitializedData;
    ULONG   AddressOfEntryPoint;
    ULONG   BaseOfCode;
    ULONG   BaseOfData;
    //
    // NT additional fields.
    //
    ULONG   ImageBase;
    ULONG   SectionAlignment;
    ULONG   FileAlignment;
    USHORT  MajorOperatingSystemVersion;
    USHORT  MinorOperatingSystemVersion;
    USHORT  MajorImageVersion;
    USHORT  MinorImageVersion;
    USHORT  MajorSubsystemVersion;
    USHORT  MinorSubsystemVersion;
    ULONG   Reserved1;
    ULONG   SizeOfImage;
    ULONG   SizeOfHeaders;
    ULONG   CheckSum;
    USHORT  Subsystem;
    USHORT  DllCharacteristics;
    ULONG   SizeOfStackReserve;
    ULONG   SizeOfStackCommit;
    ULONG   SizeOfHeapReserve;
    ULONG   SizeOfHeapCommit;
    ULONG   LoaderFlags;
    ULONG   NumberOfRvaAndSizes;
    IMAGE_DATA_DIRECTORY DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];
} IMAGE_OPTIONAL_HEADER, *PIMAGE_OPTIONAL_HEADER;
}

set OptHdr20b {typedef struct _IMAGE_OPTIONAL_HEADER {
    //
    // Standard fields.
    //
    USHORT  Magic;
    UCHAR   MajorLinkerVersion;
    UCHAR   MinorLinkerVersion;
    ULONG   SizeOfCode;
    ULONG   SizeOfInitializedData;
    ULONG   SizeOfUninitializedData;
    ULONG   AddressOfEntryPoint;
    ULONG   BaseOfCode;
    //
    // NT additional fields.
    //
    ULONG   ImageBase;
    ULONG   SectionAlignment;
    ULONG   FileAlignment;
    USHORT  MajorOperatingSystemVersion;
    USHORT  MinorOperatingSystemVersion;
    USHORT  MajorImageVersion;
    USHORT  MinorImageVersion;
    USHORT  MajorSubsystemVersion;
    USHORT  MinorSubsystemVersion;
    ULONG   Reserved1;
    ULONG   SizeOfImage;
    ULONG   SizeOfHeaders;
    ULONG   CheckSum;
    USHORT  Subsystem;
    USHORT  DllCharacteristics;
    ULONG   SizeOfStackReserve;
    ULONG   SizeOfStackCommit;
    ULONG   SizeOfHeapReserve;
    ULONG   SizeOfHeapCommit;
    ULONG   LoaderFlags;
    ULONG   NumberOfRvaAndSizes;
    IMAGE_DATA_DIRECTORY DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];
} IMAGE_OPTIONAL_HEADER, *PIMAGE_OPTIONAL_HEADER;
}

set ImgDataHdr {typedef struct _IMAGE_DATA_DIRECTORY {
    DWORD   VirtualAddress;
    DWORD   Size;
} IMAGE_DATA_DIRECTORY, *PIMAGE_DATA_DIRECTORY;
}

  proc blob2dict {strName blob} {
    set str [set [namespace current]::$strName]
    set rtnDict {}
    set offset 0
    set str [string map "\\{ _ \\} -" $str]
    foreach l [split $str \n] {
  # puts "L: $l" ; flush stdout
      lassign $l a b c
      set b [string trim $b \;]
      if {[string first {[} $b] > 0} {
        regexp {(.*)\[([0-9]+)\]} $b mm b len
      } else {
        set len 1
      }
      set hit 0
      switch $a {
        UCHAR {
  	set hit [binary scan [string range $blob $offset [expr $offset+($len-1)]] cu$len val]
  #	puts "UCOFF: $offset $b $arr($b)"
  	set offset [expr {$offset+($len)}]
        }
        USHORT {
  	set hit [binary scan [string range $blob $offset [expr $offset+(2*$len-1)]] su$len val]
  #	puts "USOFF: $offset $b $arr($b)"
  	set offset [expr {$offset+($len*2)}]
        }
        SHORT {
  	set hit [binary scan [string range $blob $offset [expr $offset+(2*$len-1)]] s$len val]
  #	puts "SOFF: $offset $b $arr($b)"
  	set offset [expr {$offset+($len*2)}]
        }
        ULONG {
  	set hit [binary scan [string range $blob $offset [expr $offset+(4*$len-1)]] iu$len val]
  #	puts "ULOFF: $offset $b $arr($b)"
  	set offset [expr {$offset+($len*4)}]
        }
        DWORD -
        LONG {
  	set hit [binary scan [string range $blob $offset [expr $offset+(4*$len-1)]] i$len val]
  #puts "HIT: $hit"
  #	puts "LOFF: $offset $b $arr($b)"
  	set offset [expr {$offset+($len*4)}]
        }
      }
      if {$hit} {
        dict append rtnDict $b $val
      }
    }
    return $rtnDict
  }

  proc structSize {str} {
    set str [string map "\\{ _ \\} -" $str]
  
    array set size {UCHAR 1 CHAR 1 SHORT 2 USHORT 2 LONG 4 ULONG 4 DWORD 4}
    set total 0
  
    foreach l [split $str \n] {
      lassign $l a b c
      set b [string trim $b \;]
      if {[string first {[} $b] > 0} {
        regexp {(.*)\[([0-9]+)\]} $b mm b len
      } else {
        set len 1
      }
      if {[info exists size($a)]} {
        incr total $size($a)
      }
    }
    return $total
  }
      
  proc hexPDict {dct} {

    dict for {el val} $dct {
      if {[llength $val] == 1} {
        if {[string first Date $el] > 0} {
          puts "$el \t[clock format $val]"
        } else {
          puts "$el \t[format %x $val] "
        }
      } else {
        set str {}
        foreach e $val {
          append str [format %c $e]
        }
        puts "$el \t[string trim $str]"
      }
    }
  }
  proc accessFile {name {fp {}} } {
    variable inputFile
    variable fileName 
    set fileName $name
    # puts "ACCESS: $fileName"
    if {$fp eq {}} {
      set inputFile [open $name]
    } else {
      set inputFile $fp
    }
    fconfigure $inputFile -encoding binary -translation binary
    seek $inputFile 0 start
    set d [read $inputFile 2]
    set hit [binary scan [string range $d 0 2] su val]
    if {$val != 0x5a4d} {
      error "Not a DOS/PE32 File"
    }
    seek $inputFile 0 start
  }

  proc ReadImgHdr {} {
    variable e_lfanew
    variable magicDict
    variable imgDict 
    variable inputFile 
    
    # puts "SEEK: [format %x [expr $e_lfanew]]"
    seek $inputFile $e_lfanew
    set d [read $inputFile 100]
  
    set magicDict [parsePE32::blob2dict MagicWord $d]
    # parsePE32::hexPDict $magicDict
  
    set imgDict [parsePE32::blob2dict ImgHdr [string range $d 4 end]] 
#    puts " -- IMG"
#    parsePE32::hexPDict $imgDict
  }
  
  proc ReadDosHdr {} {
    variable dosDict
    variable e_lfanew
    variable inputFile
    seek $inputFile 0 start

    set d [read $inputFile 70]
    set dosDict [parsePE32::blob2dict DosHdr $d]
    set e_lfanew [dict get $dosDict e_lfanew]
  }
  
  proc ReadOptHdr {} {
    variable inputFile
    variable dosDict
    variable e_lfanew
    variable imgDict 
    variable ImgHdr
    variable optHdr

    seek $inputFile [expr $e_lfanew + [structSize $ImgHdr] + 4]
    set d [read $inputFile 4]
    set magicDict [blob2dict MagicWord $d]
#    puts " -- MAGIC"
#    hexPDict $magicDict
    set magic [dict get $magicDict sig1]
    
    if {$magic == 0x20b} {
      set optHdr OptHdr20b
    } else {
      set optHdr OptHdr10b
    }

    seek $inputFile [expr $e_lfanew + [structSize $ImgHdr] + 4]
    set d [read $inputFile [dict get $imgDict SizeOfOptionalHeader]]
    set optDict [parsePE32::blob2dict $optHdr $d] 
    # parsePE32::hexPDict $optDict
    return $optDict
  }
  
  proc updateDataDir {field offset size {fp {}} } {
    variable inputFile
    variable dataDirsOffset 
    variable fileName
    variable DataDirs
    variable ImgDataHdr

# puts "FLD: $field OFFF: [format %xx $offset] SZ: $size"
    if {[set pos [lsearch $DataDirs $field]] < 0} {
      error "Invalid Field $field - Must be one of $DataDirs"
    }
    if {$fp eq ""} {
      set of [open $fileName a+]
    } else {
      set of $fp
    }
    fconfigure $of -encoding binary -translation binary
    set certOffset \
      [expr {$dataDirsOffset+ ($pos * [structSize $ImgDataHdr])}]
    seek $of $certOffset start
# puts "SEEK TO: $fileName - $certOffset [tell $of]"
    set d [read $of [structSize $ImgDataHdr]] 
    set tmp [parsePE32::blob2dict ImgDataHdr $d] 
# puts WAS
#    hexPDict $tmp
    seek $of $certOffset start
    puts $of [binary format i $offset] 
    puts $of [binary format i $size]
    if {$fp eq ""} {
      close $of
    }
  }

  proc getSectorOffset {fileName} {
    variable inputFile
    variable dosDict
    variable e_lfanew
    variable imgDict 
    variable ImgHdr
    variable optHdr
    variable OptHdr10b
    variable OptHdr20b
    variable DataDirs
    variable dataDirsOffset 


    if {![info exists inputFile]} {
      accessFile $fileName
    }
    ReadDosHdr
    ReadImgHdr
    set optDict [ReadOptHdr]
    # puts "seek $inputFile  $e_lfanew + [structSize $ImgHdr] + [structSize [set $optHdr]] + 4"
    set dataDirsOffset [expr $e_lfanew + [structSize $ImgHdr] + [structSize [set $optHdr]] + 4]

    seek $inputFile $dataDirsOffset 

    foreach k  $DataDirs {
#   puts " -- $k [tell $inputFile]"
      set d [read $inputFile [parsePE32::structSize $parsePE32::ImgDataHdr]] 
      dict append rtn $k [parsePE32::blob2dict ImgDataHdr $d] 
      if {[incr i] > [dict get $optDict NumberOfRvaAndSizes]} {break}
#    hexPDict [parsePE32::blob2dict ImgDataHdr $d] 

    }
#    puts "RTN $rtn"
    return $rtn
  }
}

if {[info exists argv] && ([lsearch $argv -testPE32] >= 0)} {
set sectors [parsePE32::getSectorOffset [lindex $argv end]]

set off1 [dict get $sectors Certificate VirtualAddress]
puts "OFFSET FOR CERT: $off1"

set if [open [lindex $argv end] r]
fconfigure $if -encoding binary -translation binary
seek $if $off1
  set d [read $if [dict get $sectors Certificate Size]]
  if {[set p1 [string first "Noumena" $d]] > 0} {
    puts "P1: $p1 CERT BY: [string range $d $p1 [expr $p1+18]]"
  }

dict for {k v} $sectors {
  puts "$k - [format %x [dict get $v VirtualAddress]]  [format %x [dict get $v Size]]"
}

seek $if [expr $off1 - 256]
set d [read $if 256]
set p [string first "TCLF" $d]
puts "P: $p"
incr p 4
binary scan [string range $d $p [expr $p+7]] w offset
puts "OFFSET: [format %xx $offset]"
exit
}
